#!/usr/local/bin/perl
# * ====================================================================
# * Copyright (c) 1995,1996, ISIS/JRC.  All rights reserved.
# *
# * This product was developed within the Institute for Safety, Informatics
# * and Systems of the Joint Research Centre of the European Commission.
# *
# * More information about us; and this software product can
# * be found on http://www.jrc.it.
# *
# * With this file you should have received a file called 'License'.
# *
# * Redistribution and use in source and binary forms, with or without
# * modification, are permitted provided that the following conditions
# * are met:
# *
# * 1. Redistributions of source code must retain the above copyright
# *    notice, this list of conditions and the following disclaimer.
# *
# * 2. Redistributions in binary form must reproduce the above copyright
# *    notice, this list of conditions and the following disclaimer in
# *    the documentation and/or other materials provided with the
# *    distribution.
# *
# * 3. All materials mentioning features or use of this
# *    software must display the following acknowledgment:
# *    "This product includes software developed by ISIS/JRC"
# *
# * 4. The name of the Copyright holder must not be used to
# *    endorse or promote products derived from this software without
# *    prior written permission.
# *
# * 5. Redistributions of any form whatsoever must retain the following
# *    acknowledgment:
# *    "This product includes software developed by ISIS/JRC"
# *
# * THIS SOFTWARE IS PROVIDED BY ISIS/JRC ``AS IS'' AND ANY
# * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ISIS/JRC OR
# * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# * OF THE POSSIBILITY OF SUCH DAMAGE.
# * ====================================================================
#


use strict;

use CGI qw/:standard/;

use Display;

my $selected_category = CGI::param('category');
my $selected_server = CGI::param('server');
my $selected_dbase = CGI::param('dbase');

my $selection = 'category';
$selection = 'server'
   if $selected_category;
$selection = 'dbase'
   if $selected_server;
if ( $selected_dbase ) {
   print Display::HTML::Page(500, "Invalid request, dbase is already selected");
   exit 0;
}

require 'categories.pl';

my $selecturl = $::docurlroot . '/dbase_select.pl';
my $searchurl = $::docurlroot . '/search.pl';


my ($category, $server, $dbase);

my $msg = qq|
The categories below are an illustration of what is possible. No proper
categorisation has yet been done.
<UL>
|;

foreach $category ( sort { $::categories->{$a}->{title} cmp $::categories->{$b}->{title} } 
                    keys %{ $::categories } ) {
   my $cat = $::categories->{$category};
   my $title = $cat->{title} || $category;
   $msg .= "\t<LI>";
   $msg .= "<A HREF=\"$selecturl?category=$category#CAT$category\">$title</A>";
   if ( $category eq $selected_category ) {
      $msg .= "<A NAME=\"CAT$category\">:</A>\n\t<UL>\n";
      foreach $server ( sort { $cat->{server}->{$a}->{title} cmp $cat->{server}->{$b}->{title} }
                        keys %{ $cat->{server} } ) {
         my $serv = $cat->{server}->{$server};
         my $title = $serv->{title} || $server;
         $msg .= "\t\t<LI>";
         $msg .= "<A HREF=\"$selecturl?category=$category\&server=$server#SVR$server\">$title</A>";
         if ( $server eq $selected_server ) {
            $msg .= "<A NAME=\"SVR$server\">:</A>\n\t\t<UL>\n";
            foreach $dbase ( sort { $serv->{dbase}->{$a}->{title} cmp $serv->{dbase}->{$b}->{title} } 
                             keys %{ $serv->{dbase} } ) {
               my $db = $serv->{dbase}->{$dbase};
               my $title = $db->{title} || $dbase;
               $msg .= "\t\t\t<LI>";
               $msg .= "<A HREF=\"$searchurl?server=$server\&dbase=$dbase#DB$dbase\">$title</A>\n";
            }
            $msg .= "\t\t</UL>\n";
         } else {
            $msg .= "\n";
         }
      }
      $msg .= "\t</UL>\n";
   } else {
      $msg .= "\n";
   }
}
$msg .= "</UL>\n";

print Display::HTML::Page(200, "Please select a $selection", $msg);
exit 0;
